	;spaghetti code - we salute you!

kernel_main: subroutine
	sta WSYNC
.loop:
	sta GRP1				;3			;activates GRP0 and ENABL with vdel on
	txa						;2

	sbc liney				;3
	cmp #platheight			;2
	bcs .noplat				;2/3

		adc platcolor		;3
		sta COLUPF			;3

		;update PF by 22.2, 28, 38.2, 49.1, 54.2, 65.1
		;second half must be after 28, 38.2, 49.1

		;ldy linegfx0		;3
		sty PF0				;3 = 21
		ldy linegfx1		;3
		sty PF1				;3 = 27
		ldy linegfx2		;3		
		sty PF2				;3 = 33
		ldy linegfx3		;3
		sty PF0				;3 = 39
		ldy linegfx4		;3
		sty PF1				;3 = 45
		ldy linegfx5		;3
		sty PF2				;3 = 51

		tay					;2
		lda (p0bufptr),y	;5
		sta GRP0			;3
		lda (p1bufptr),y	;5 = 66
		ldy linegfx0		;3
		sec					;2

		dex					;2
		bne .loop			;3 = 76
		beq start_overscan


.clearpf:
	;18 prior cycles
	;a = 0
	;c set

	sta PF0					;3 = 21
	sta PF1					;3 = 24
	sta PF2					;3 = 27
	nop 0					;3
	bcs .draw_players		;3 = 33


.noplat:
	;before/at liney, do nothing extra
	;1-6	draw playfield
	;7		clear playfield
	;8-13	transfer the next buffer to linegfx
	;14-17	transfer the next player buffer pointers
	;18		transfer the next platform color
	;19		advance the platform buffer
	;20		update liney

	;13 prior cycles
	;c clear

	adc #0					;2
	bcs .clearpf			;2/3
	bpl .donothing			;2/3
	adc #14					;2

		tay					;2
		lda (linebufptr),y	;5
		sta platform_data,y	;5 = 33


.draw_players:

	;43 cycles to draw both players

	txa						;2
	sbc p0y					;3
	adc #playerheight		;2
	bcc .nop0				;2/3
		tay					;2
		lda (p0gfxptr),y	;5
		sta GRP0			;3
.drawp1:
	txa						;2
	sbc p1y					;3
	adc #playerheight		;2
	bcc .nop1				;2/3
		tay					;2
		lda (p1gfxptr),y	;5
	ldy linegfx0		;3
	dex						;2
	bne .loop				;3 = 76
	beq start_overscan	

.nop1:
	;alternate ending - no time to branch back
	;should take 11 cycles
	nop						;2
	sec						;2
	lda #0					;2
	ldy linegfx0			;3
	dex						;2
	bne .loop				;3 = 76
	beq start_overscan

.nop0:
	nop						;2
	nop						;2
	sec						;2
	bcs .drawp1				;3


.donothing:
	;20 prior cycles
	;c clear

	cmp #balltop+platheight+1	;2
	bcs .prebonus			;2/3

		adc platcolor		;3
		tay					;2
		dey					;2
		lda bonus			;3
		cmp linebufptr		;3
		bne .nobonus		;2/3

		;c set when equal
		lda (ballptr),y		;5
		sta ENABL			;3 = 47
.rejoin_bonus:
		lda colubonus		;3
		sta COLUPF			;3 = 53
	
		lda (p0bufptr),y	;5
		sta GRP0			;3
		lda (p1bufptr),y	;5
		ldy linegfx0		;3
		dex					;2
		beq start_overscan	;2
		jmp .loop			;3 = 76

.nobonus:
	;40
	nop						;2
	sec						;2
	bcs .rejoin_bonus		;3

.prebonus:
	;25
	dec $2d					;5
	bcs .draw_players		;3 = 33