	MAC SUBSOUND
.duration	SET {1}
.frequency	SET {2}
.volume		SET {3}
.control	SET {4}

	.byte .duration*32 + .frequency
	.byte .volume*16 + .control
	ENDM


sound_priorities:
	.byte 0
	.byte 3
	.byte 3
	.byte 5
	.byte 5
	.byte 1
	.byte 4
	.byte 4
	.byte 2
	.byte 6
	.byte 2

sound_subsounds equ *-1
	;.byte 0
	.byte 7
	.byte 7
	.byte 5
	.byte 9
	.byte 5
	.byte 5
	.byte 5
	.byte 7
	.byte 9
	.byte 3

sound_data_lsb equ *-1
	;.byte <sound_start
	.byte <cap0data
	.byte <cap1data
	.byte <diedata
	.byte <respawndata
	.byte <bouncedata
	.byte <collectdata
	.byte <firedata
	.byte <warpdata
	.byte <startupdata
	.byte <selectdata

sound_start:
	;order is duration (3) | frequency (5), volume (4) | control (4)

	;don't forget the subsounds are stored backwards!

	;15 uneven grindy motor noise
	;14 slower soft zippery buzz
	;13 very similar to 12
	;12 basic beep
	;11 same as 0
	;10 soft rapid zippery buzz
	;9 buzz, little more even than 7
	;8 scratchy blow-up noise
	;7 buzz
	;6 faster (?) buzz
	;5 annoying digitalish beep
	;4 very similar to 5
	;3 wavey hollow-sounding buzz, weird
	;2 clicky popish scratch noise
	;1 smoother (?) fast buzz
	;0 soft pop noise, effectively no sound

sound_capture_0		equ 1
cap0data:
	SUBSOUND 1, 14, 1, 12
	SUBSOUND 1, 14, 4, 12
	SUBSOUND 5, 14, 6, 12
	SUBSOUND 1, 18, 6, 12
	SUBSOUND 1, 20, 5, 12
	SUBSOUND 1, 22, 4, 12
	SUBSOUND 1, 24, 3, 12

sound_capture_1		equ 2
cap1data:
	SUBSOUND 1, 24, 1, 12
	SUBSOUND 1, 24, 4, 12
	SUBSOUND 5, 24, 6, 12
	SUBSOUND 1, 20, 6, 12
	SUBSOUND 1, 18, 5, 12
	SUBSOUND 1, 16, 4, 12
	SUBSOUND 1, 14, 3, 12

sound_die			equ 3
diedata:
	SUBSOUND 7, 28, 3, 8
	SUBSOUND 5, 18, 4, 8
	SUBSOUND 5, 26, 8, 8
	SUBSOUND 5, 20, 14, 8
	SUBSOUND 5, 24, 15, 8

sound_respawn		equ 4
respawndata:
	SUBSOUND 5, 22, 5, 3
	SUBSOUND 2, 22, 10, 3
	SUBSOUND 0, 21, 8, 3
	SUBSOUND 2, 26, 7, 3
	SUBSOUND 1, 26, 13, 3
	SUBSOUND 0, 25, 11, 3
	SUBSOUND 2, 30, 9, 3
	SUBSOUND 1, 30, 15, 3
	SUBSOUND 0, 29, 13, 3

sound_bounce		equ 5
bouncedata:
	SUBSOUND 2, 11, 3, 7
	SUBSOUND 2, 11, 4, 7
	SUBSOUND 1, 11, 5, 7
	SUBSOUND 1, 12, 7, 7
	SUBSOUND 2, 11, 10, 7

sound_collect		equ 6
collectdata:
	SUBSOUND 3, 10, 4, 4
	SUBSOUND 3, 10, 8, 4
	SUBSOUND 2, 10, 13, 4
	SUBSOUND 1, 16, 6, 4
	SUBSOUND 1, 16, 11, 4

sound_fire			equ 7
firedata:
	SUBSOUND 2, 18, 4, 5
	SUBSOUND 3, 18, 8, 5
	SUBSOUND 2, 18, 13, 5
	SUBSOUND 1, 11, 6, 5
	SUBSOUND 1, 11, 11, 5

sound_warp			equ 8
warpdata:
	SUBSOUND 1, 8, 2, 7
	SUBSOUND 2, 8, 4, 7
	SUBSOUND 1, 9, 6, 7
	SUBSOUND 1, 10, 8, 7
	SUBSOUND 0, 12, 8, 7
	SUBSOUND 0, 14, 7, 7
	SUBSOUND 0, 15, 6, 7

sound_startup		equ 9
startupdata:
	SUBSOUND 2, 20, 6, 12
	SUBSOUND 3, 20, 12, 12
	SUBSOUND 3, 20, 15, 12
	SUBSOUND 1, 23, 6, 12
	SUBSOUND 1, 23, 9, 12
	SUBSOUND 1, 23, 12, 12
	SUBSOUND 1, 27, 6, 12
	SUBSOUND 1, 27, 9, 12
	SUBSOUND 1, 27, 12, 12 

sound_select		equ 10
selectdata:
	SUBSOUND 1, 1, 5, 15
	SUBSOUND 1, 1, 9, 15
	SUBSOUND 1, 2, 15, 15